<?php defined('SYSPATH') or die('No direct script access.');
 
class Controller_Student_Index extends Controller_UserEnvironment
{
    public function action_index() {
        $student_id = $this->user['StudentID'];
        $disciplines = Model_Student::load($student_id)->getDisciplines();

        foreach ($disciplines as $dis) {
            switch ($dis->Subtype) {
                case 'disciplinary_coursework':
                    $dis->Teachers = ['Курсовая']; break;
                case 'scientific_coursework':
                    $dis->Teachers = ['Науч. рук.']; break;
                default:
                    $dis->Teachers = self::getTeachersForDiscipline($dis->ID);
            }

            $dis->Control = DataHelper::LocalizeExamType($dis->Type);
            # fixme: ExamRate is not defined in the `GetDisciplinesForStudent` function!
            $dis->ColorScheme = Model_Subject::getECTSMark($dis->Rate, $dis->MaxCurrentRate, NULL /*$dis['examRate']*/);
        }

        $this->twig->set([
            'disciplines'  => $disciplines,
            'Semester'     => $this->SemesterInfo,
            'SemesterList' => Model_Semesters::toArray(),
        ])->set_filename('student/index');
    }

    /**
     * @param $id int discipline id
     * @return array list of short-form names
     */
    private static function getTeachersForDiscipline($id) {
        $teachers = Model_Discipline::load($id)->getTeachers();

        $list = array();
        foreach ($teachers as $teacher)
            $list[] = DataHelper::AbbreviateName($teacher);

        return $list;
    }

    public function action_settings() {
        $this->twig->set_filename('settings');
    }
}
            
